﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ExcelImport;
using System.Linq;
using System.Data.Entity;
using Syncfusion.Linq;

using Syncfusion.XlsIO;
using System.Collections;
using Syncfusion.JavaScript.DataSources;
using System.Data;
namespace ExcelImport.Controllers
{
    public class GridController : Controller
    {
        //
        // GET: /Grid/
        static List<Orders> order = new List<Orders>();
        public ActionResult GridFeatures()
        {
            return View();
        }
        public ActionResult BatchDataSource(Syncfusion.JavaScript.DataManager dm)
        {
            IEnumerable DataSource = GetAllRecords().ToList();
            BatchDataResult result = new BatchDataResult();
            DataOperations obj = new DataOperations();
            if (dm.Skip != 0)
            {
                DataSource = obj.PerformSkip(DataSource, dm.Skip);
            }
            if (dm.Take != 0)
            {
                DataSource = obj.PerformTake(DataSource, dm.Take);
            }
            result.result = DataSource;
            result.count = GetAllRecords().Count();
            return Json(result, JsonRequestBehavior.AllowGet);
        }
        public ActionResult BatchUpdate(List<Orders> changed, List<Orders> added, List<Orders> deleted)
        {
            if (changed != null)
            {
                foreach (var temp in changed)
                {
                    Orders result = GetAllRecords().Where(o => o.OrderID == temp.OrderID).FirstOrDefault();
                    if (result != null)
                    {
                        result.OrderID = temp.OrderID;
                        result.OrderDate = temp.OrderDate;
                        result.CustomerID = temp.CustomerID;
                        result.EmployeeID = temp.EmployeeID;
                        result.Freight = temp.Freight;
                        result.ShipCity = temp.ShipCity;
                        
                    }
                }
            }
            if (deleted != null)
            {
                foreach (var temp in deleted)
                {
                    Orders result = GetAllRecords().Where(o => o.OrderID == temp.OrderID).FirstOrDefault();
                    GetAllRecords().Remove(result);
                }
            }

            if (added != null)
            {
                foreach (var temp in added)
                    GetAllRecords().Insert(0, temp);
            }
               
            var data = GetAllRecords();
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        //Convert the Data table to list
        public List<Orders> GetAllRecords()
        {
            
            System.Data.DataTable dt = ExcelGridImport();
            if (order.Count == 0)
            {
                order = (from DataRow dr in dt.Rows
                         select new Orders()
                             {
                                 OrderID = Convert.ToInt32(dr["Order ID"]),
                                 OrderDate = Convert.ToDateTime(dr["Order Date"]),
                                 CustomerID = dr["Customer ID"].ToString(),
                                 EmployeeID = Convert.ToInt32(dr["Employee ID"]),
                                 Freight = Convert.ToDecimal(dr["Freight"]),
                                 ShipCity = dr["Ship City"].ToString()

                             }).ToList();
            }
            return order;
        }
        public System.Data.DataTable ExcelGridImport()
        {
            ExcelEngine excelEngine = new ExcelEngine();
            IApplication application = excelEngine.Excel;
            //Open the workbook from mentioned path
            IWorkbook workbook = application.Workbooks.Open(Request.PhysicalApplicationPath + "/ExportSheet.xlsx");
            IWorksheet empSheet = workbook.Worksheets[0];
            //Records in excel file are fill into the datatable 
            System.Data.DataTable customersTable = empSheet.ExportDataTable(empSheet.UsedRange, ExcelExportDataTableOptions.ColumnNames);

            return customersTable;
        }
    }
    public class Orders
    {
        public int OrderID { get; set; }
        public int EmployeeID { get; set; }
        public string CustomerID { get; set; }
        public DateTime OrderDate { get; set; }
        public string ShipCity { get; set; }
        public Decimal Freight { get; set; }
                  
    }
    public class BatchDataResult
    {
        public IEnumerable result { get; set; }
        public int count { get; set; }
    }
}
